#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

#include "pattern.h"
#include "All2WEB.h"

char *Strings[]={Item1,Item2,Item3,NULL,Head1,Head2,Head3,Head4,NULL};
//                  0   1     2      3    4     5     6    7     8
#define Str0 4

#define BUFSIZE 16384
#define NFrom   16
#define NSubj   16

#define Cmp12(x,y) strncmp(x,y,strlen(x))
//#define cmp12(x,y) Lstrnicmp(x,y,strlen(x))

int cmp12(char *s1, char *s2)
{
int n=strlen(s1);
int i;

if (n>strlen(s2))
   return(1);

for (i=0;i<n;i++)
    if (tolower(s1[i])!=tolower(s2[i]))
       return((tolower(s1[i])-tolower(s2[i])));
return(0);
}

int contain(char * src,char * mask)
{
int i;

for (i=0;src[i];i++)
    if (!cmp12(mask,src+i))
       return(1);
return(0);
}

int NDot(char *p)
{
int  n;

if ((*p<'1') || (*p>'9'))
   return(0);
n=*(p++)-'0';

if (*p=='.')
   {
   *p=0;
   return(n);
   }

if ((*p<'0') || (*p>'9'))
   return(0);
n=n*10+*(p++)-'0';

if (*p=='.')
   {
   *p=0;
   return(n);
   }
else
   return(0);
}

void OutText(char *p)
{
char c;

while ((c=*p++)!=0)
      switch(c)
           {
           case '<':
                fputs("&lt;",stdout);
                break;
           case '>':
                fputs("&gt;",stdout);
                break;
           case '&':
                fputs("&amp;",stdout);
           default:
                fputc(c,stdout);
           }

}

#define MODE_DEVELOP   0
#define MODE_GETDATE   1
#define MODE_GETITEM   2


int main(int argc, char *argv[])
{
char buf[BUFSIZE];
char *froms[NFrom];
char *subjs[NSubj];
char c;
int from=0,subj=0;
int newmode=0;
int mode=MODE_DEVELOP;
int StrIndex;

opterr = 1;

for (int i=0;i<NFrom;i++)
    froms[i]=NULL;

for (int i=0;i<NSubj;i++)
    subjs[i]=NULL;

while ((c=getopt(argc, argv, "idf:s:")) != -1)
      switch(c)
        {
        case 'f':
             for (int i=0;i<NFrom;i++)
                 if (froms[i]==NULL)
                    {
                    froms[i]=optarg;
                    break;
                    }
             break;
        case 's':
             for (int i=0;i<NSubj;i++)
                 if (subjs[i]==NULL)
                    {
                    subjs[i]=optarg;
                    break;
                    }
             break;
        case 'd':
             mode=MODE_GETDATE;
             break;

        case 'i':
             mode=MODE_GETITEM;
             break;
        
        case '?':
            return(-1);
        }

if (argc>optind)
   {
   fputs("All2WEB: Too many arguments :-(\n",stderr);
   return(-1);
   }

while ((fgets(buf,BUFSIZE-2,stdin)!=NULL) && (strlen(buf)!=1))
      {
      if (!Cmp12("From: ",buf))
         for (int i=0;i<NFrom;i++)
                 if ((froms[i]!=NULL)&& contain(buf,froms[i]))
                    {
                    from=1;
                    break;
                    }

      if (!Cmp12("Subject: ",buf))
         for (int i=0;i<NSubj;i++)
                 if ((subjs[i]!=NULL)&& contain(buf,subjs[i]))
                    {
                    subj=1;
                    break;
                    }
      }

if (!(subj && from))
   {
   fputs("All2WEB: The message not qualified.\n",stderr);
   return(-1);
   }

if (mode==MODE_GETDATE)
   {
   fputs("All2WEB: The message qualified - trying to get date.\n",stderr);

   while ((fgets(buf,BUFSIZE-2,stdin)!=NULL) && (!NDot(buf)))
      {
      char *p;
      
      if ((p=a2d((unsigned char *)buf))!=NULL)
         {
         fputs(p,stdout);
         fputs("All2WEB: Success - date string decoded :-)\n",stderr);
         return(0);
         }
      }
   fputs("All2WEB: Couldn't find date string :-(\n",stderr);
   return(-1);
   }

if (mode==MODE_GETITEM)
   {
   fputs("All2WEB: The message qualified - trying to get item.\n",stderr);
   while ((fgets(buf,BUFSIZE-2,stdin)!=NULL) && (!NDot(buf)))
         OutText(buf);
   fputs("All2WEB: Success: item is extracted :-)\n",stderr);
   return(0);
   }

fputs("All2WEB: The message qualified - trying to convert.\n",stderr);
ungetc('\n',stdin);

for (StrIndex=Str0;fgets(buf,BUFSIZE-2,stdin)!=NULL;)
    if ((*buf=='\n') || (strspn(buf," \t\n")==strlen(buf)))
       {
       if (newmode)
          continue;
       newmode=1;
       if (Strings[StrIndex]!=NULL)
          fputs(Strings[StrIndex++],stdout);
       }
    else
       {
       newmode=0;
       if (NDot(buf))
          {
          while(Strings[StrIndex]!=NULL)
               fputs(Strings[StrIndex++],stdout);
          fputs(Strings[0],stdout);
          OutText(buf+strlen(buf)+1);
          StrIndex=1;
          }
       else
          OutText(buf);
       }

while(Strings[StrIndex]!=NULL)
     fputs(Strings[StrIndex++],stdout);

time_t now;
time(&now);

fputs(HappyEnd1,stdout);
fputs(asctime(localtime(&now)),stdout);
fputs(HappyEnd2,stdout);

fputs("All2WEB: Success - converted :-)\n",stderr);

return(0);
}

